Xapian: API Documentation: xapian-core: Xapian::DateValueRangeProcessor Class Reference

# Xapian::DateValueRangeProcessor Class Reference

Handle a date range. More...

Inheritance diagram for Xapian::DateValueRangeProcessor:

[legend]

List of all members.

## Public Member Functions
| DateValueRangeProcessor (Xapian::valueno slot_, bool prefer_mdy_=false, int epoch_year_=1970)
| Constructor.
| DateValueRangeProcessor (Xapian::valueno slot_, const std::string &str_, bool prefix_=true, bool prefer_mdy_=false, int epoch_year_=1970)
| Constructor.
Xapian::valueno | operator() (std::string &begin, std::string &end)
| Check for a valid date range.

## Detailed Description

Handle a date range.

Begin and end must be dates in a recognised format.

## Constructor & Destructor Documentation

Xapian::DateValueRangeProcessor::DateValueRangeProcessor | ( | Xapian::valueno | slot_,
|  | bool | prefer_mdy_ = `false`,
|  | int | epoch_year_ = `1970` |
| ) |  |  | `[inline]`

Constructor.

Parameters:

  | slot_ | The value number to return from operator().
  | prefer_mdy_ | Should ambiguous dates be interpreted as month/day/year rather than day/month/year? (default: false)
  | epoch_year_ | Year to use as the epoch for dates with 2 digit years (default: 1970, so 1/1/69 is 2069 while 1/1/70 is 1970).

Xapian::DateValueRangeProcessor::DateValueRangeProcessor | ( | Xapian::valueno | slot_,
|  | const std::string & | str_,
|  | bool | prefix_ = `true`,
|  | bool | prefer_mdy_ = `false`,
|  | int | epoch_year_ = `1970` |
| ) |  |  | `[inline]`

Constructor.

Parameters:

  | slot_ | The value number to return from operator().
  | str_ | A string to look for to recognise values as belonging to this date range.
  | prefix_ | Whether to look for the string at the start or end of the values. If true, the string is a prefix; if false, the string is a suffix (default: true).
  | prefer_mdy_ | Should ambiguous dates be interpreted as month/day/year rather than day/month/year? (default: false)
  | epoch_year_ | Year to use as the epoch for dates with 2 digit years (default: 1970, so 1/1/69 is 2069 while 1/1/70 is 1970).

The string supplied in str_ is used by operator() to decide whether the pair of strings supplied to it constitute a valid range. If prefix_ is true, the first value in a range must begin with str_ (and the second value may optionally begin with str_); if prefix_ is false, the second value in a range must end with str_ (and the first value may optionally end with str_).

If str_ is empty, the setting of prefix_ is irrelevant, and no special strings are required at the start or end of the strings defining the range.

The remainder of both strings defining the endpoints must be valid dates.

For example, if str_ is "created:" and prefix_ is true, and the range processor has been added to the queryparser, the queryparser will accept "created:1/1/2000..31/12/2001".

## Member Function Documentation

Xapian::valueno Xapian::DateValueRangeProcessor::operator() | ( | std::string & | begin,
|  | std::string & | end |
| ) |  |  | `[virtual]`

Check for a valid date range.

Parameters:

  `[in,out]` | begin | The start of the range as specified in the query string by the user. This parameter is a non-const reference so the ValueRangeProcessor can modify it to return the value to start the range with.
  `[in,out]` | end | The end of the range. This is also a non-const reference so it can be modified.

Returns:
  If BEGIN..END is a sensible date range, this method modifies them into the format YYYYMMDD and returns the value of slot_ passed at construction time. Otherwise it returns Xapian::BAD_VALUENO.

Reimplemented from Xapian::StringValueRangeProcessor.

The documentation for this class was generated from the following file:

- xapian/queryparser.h